﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace automata
{
    class Rekesz
    {
        public int Id { get; set; }
        public int Db { get; set; }
        public int Ár { get; set; }
        public Rekesz(int _id, int _db, int _ár)
        {
            Id = _id;
            Db = _db;
            Ár = _ár;
        }
    }

    class Vétel
    {
        public int RekeszId { get; set; }
        public int Db { get; set; }
        int[] címlet = { 1, 2, 5, 10, 20, 50, 100 };
        int[] bankjegy = new int[7];
        public int[] Bankjegy { get { return bankjegy; } set { bankjegy = value; } }
        public Vétel(string[] adat)
        {
            RekeszId = Convert.ToInt32(adat[0]);
            Db = Convert.ToInt32(adat[1]);
            for (int i = 0; i < 7; i++)
            {
                bankjegy[i] = Convert.ToInt32(adat[i + 2]);
            }
        }

        public int Összeg
        {
            get
            {
                int szum = 0;
                for (int i = 0; i < 7; i++)
                {
                    szum += (címlet[i] * bankjegy[i]);
                }
                return szum;
            }
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            #region adatbeolvasás;
            StreamReader be = new StreamReader("csoki.txt");
            int rekdb = Convert.ToInt32(be.ReadLine());
            List<Rekesz> Gép = new List<Rekesz>();
            for (int i = 0; i < rekdb; i++)
            {
                string[] adat = be.ReadLine().Split(' ');
                Gép.Add(new Rekesz(Convert.ToInt32(adat[0]), Convert.ToInt32(adat[1]), Convert.ToInt32(adat[2])));
            }
            be.Close();
            be = File.OpenText("vasarlas.txt");
            int vételdb = Convert.ToInt32(be.ReadLine());
            List<Vétel> Forgalom = new List<Vétel>();
            for (int i = 0; i < vételdb; i++)
            {
                Forgalom.Add(new Vétel(be.ReadLine().Split(' ')));
            }
            be.Close();
            #endregion;
            #region összérték;
            int érték = 0;
            foreach (Rekesz rek in Gép)
            {
                érték += rek.Ár * rek.Db;
            }
            Console.WriteLine("2. feladat: Az automatában {0} fabatka értékű csokoládé van.", érték);
            #endregion;
            #region használt rekeszek;
            int[] usedrek = new int[rekdb+1];
            for (int i = 1; i <= rekdb; i++) {usedrek[i] = 0;}
            foreach (Vétel vesz in Forgalom)
            {
                usedrek[vesz.RekeszId]++;
            }
            Console.Write("3. feladat: A következő rekeszekből próbáltak csokit venni: ");
            for (int i = 1; i <= rekdb; i++)
            {
                if (usedrek[i] > 0)
                {
                    Console.Write(i + ", ");
                }
            }
            Console.WriteLine("\b\b ");
            #endregion;
            #region 7csoki;
            Console.Write("4. feladat Kérem a pénzösszeget! ");
            int pénz = Convert.ToInt32(Console.ReadLine());
            foreach (Rekesz rek in Gép)
            {
                if ((rek.Ár*7<pénz) && (rek.Db > 7))
                {
                    Console.Write(rek.Id + ", ");
                }
            }
            Console.WriteLine("\b\b ");

            #endregion;
            #region címletezés;
            Console.Write("5. feladat Melyik rekeszből szeretne vásárolni? ");
            int rekszám = Convert.ToInt32(Console.ReadLine());
            Console.Write("\tMennyi csokit kér? ");
            int ár = Convert.ToInt32(Console.ReadLine());
            foreach (Rekesz rek in Gép)
            {
                if (rek.Id == rekszám)
                {
                    ár *= rek.Ár;
                }
            }
            Console.WriteLine("A szükséges címletek:");
            int[] címlet = { 100, 50, 20, 10, 5, 2, 1 };
            for (int i = 0; i < 7; i++)
            {
                if (ár >= címlet[i])
                {
                    Console.WriteLine("{0}\t{1}", címlet[i], ár/címlet[i]);
                    ár = ár % címlet[i];
                }
            }
            #endregion;
            #region 7-es rekeszből;
            StreamWriter ki = new StreamWriter("rekesz7.txt");
            int sorszám = 0;
            Rekesz hetes = Gép.Find(e=>e.Id==7);
            foreach (Vétel vesz in Forgalom)
            {
                sorszám++;
                if (vesz.RekeszId == 7)
                {
                    ki.Write(sorszám + "\t");
                    if (vesz.Db > hetes.Db)
                    {
                        ki.WriteLine("kevés a csoki");
                    }
                    else if (vesz.Összeg < (hetes.Ár*vesz.Db))
                    {
                        ki.WriteLine("nem volt elég pénz");
                    }
                    else
                    {
                        ki.WriteLine(vesz.Db);
                        hetes.Db -= vesz.Db;
                    }
                }
            }
            ki.Close();
            #endregion;
            Console.ReadLine();
        }
    }
}
